package com.zanxiang.common.domain;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.stereotype.Component;

/**
 * @author xufeng
 * @date 2022/7/15 12:00
 */
@Component
@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class MiPayConfig {

    /**
     * 微信小程序appId
     */
    @ApiModelProperty(notes = "微信小程序appId")
    private String wxAppId;

    /**
     * 米大师支付应用id
     */
    @ApiModelProperty(notes = "米大师支付应用id")
    private String appId;

    /**
     * 米大师现网AppKey
     */
    @ApiModelProperty(notes = "米大师现网AppKey")
    private String appKey;

    /**
     * 米大师沙箱AppKey
     */
    @ApiModelProperty(notes = "米大师沙箱AppKey")
    private String appKeyDev;

    /**
     * 人民币元宝比例
     */
    @ApiModelProperty(notes = "人民币元宝比例")
    private String exchangeRate;

    /**
     * IOS充值提示
     */
    @ApiModelProperty(notes = "IOS充值提示")
    private String iosTips;
}
