package com.zanxiang.common.utils;

import java.util.Random;
import java.util.concurrent.ThreadLocalRandom;

public class RandomStringUtil {
    public static final Random RANDOM = ThreadLocalRandom.current();
    private static final char[] numChars = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9'};
    private static final char[] abcChars = {'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z'};
    private static final char[] ABCChars = {'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'};
    private static final char[] abcNumChars = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z'};

    public static String randomAbcNumStr(int length, boolean firstNum) {
        if (length <= 0) {
            throw new RuntimeException("Random string, length cannot be less than 0");
        }
        char[] chars = new char[length];
        if (firstNum) {
            for (int i = 0; i < length; i++) {
                chars[i] = randomChar(abcNumChars);
            }
        } else {
            chars[0] = randomChar(abcChars);
            for (int i = 1; i < length; i++) {
                chars[i] = randomChar(abcNumChars);
            }
        }
        return new String(chars);
    }

    public static String randomNumStr(int length) {
        if (length <= 0) {
            throw new RuntimeException("Random string, length cannot be less than 0");
        }
        char[] chars = new char[length];
        for (int i = 0; i < length; i++) {
            chars[i] = randomChar(numChars);
        }
        return new String(chars);
    }

    public static String randomStr(char[] chars, int length) {
        if (length <= 0) {
            throw new RuntimeException("Random string, length cannot be less than 0");
        }
        char[] result = new char[length];
        for (int i = 0; i < length; i++) {
            result[i] = randomChar(chars);
        }
        return new String(result);
    }


    private static char randomChar(char[] chars) {
        return chars[RANDOM.nextInt(chars.length)];
    }
}
