package com.zanxiang.sdk.domain.params;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * 游戏角色
 *
 * @author : xufeng
 * @time : 2022-07-21
 */
@Data
public class GameUserRoleUpdateParam {

    @ApiModelProperty("游戏id")
    @NotNull(message = "游戏id不可为空")
    private Long gameId;

    @ApiModelProperty("上报类型")
    @NotNull(message = "上报类型不可为空")
    private Integer dataType;

    @ApiModelProperty("角色id")
    @NotBlank(message = "角色id不可为空")
    private String roleId;

    @ApiModelProperty("角色名称")
    @NotBlank(message = "角色名称不可为空")
    private String roleName;

    @ApiModelProperty("角色等级")
    @NotNull(message = "角色等级不可为空")
    private Long roleLevel;

    @ApiModelProperty("游戏服务器id")
    @NotBlank(message = "游戏服务器id不可为空")
    private String serverId;

    @ApiModelProperty("所在服务器名称")
    @NotBlank(message = "所在服务器名称不可为空")
    private String serverName;

    @ApiModelProperty("角色创建时间")
    @NotNull(message = "角色创建时间不可为空")
    private LocalDateTime roleCreateTime;

    //---------------- 非必传参数 ----------------

    @ApiModelProperty("游戏区服id")
    private Long regionalId;

    @ApiModelProperty("游戏区服名称")
    private String regionalName;

    @ApiModelProperty("角色VIP")
    private Long roleVipLevel;

    @ApiModelProperty("玩家角色战力")
    private Long rolePower;

    @ApiModelProperty("平台币余额")
    private BigDecimal platformCoin;

    @ApiModelProperty("充值金额")
    private BigDecimal rechargeMoney;

    @ApiModelProperty("充值次数")
    private Integer rechargeCount;

    @ApiModelProperty("最近充值时间")
    private LocalDateTime lastRechargeTime;

    @ApiModelProperty("扩展信息")
    private String ext;

    @ApiModelProperty("角色最后登录时间")
    private LocalDateTime lastLoginTime;
}
