package com.zanxiang.sdk.domain.params;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.validation.constraints.NotBlank;

/**
 * @author : lingfeng
 * @time : 2022-06-14
 * @description : 用户名密码注册
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class RegisterPasswordParam extends CommonParam {

    private static final long serialVersionUID = 4303428251439433594L;

    /**
     * 用户名
     */
    @ApiModelProperty(notes = "用户名")
    @NotBlank(message = "注册用户名字不可为空")
    private String username;

    /**
     * 密码
     */
    @ApiModelProperty(notes = "密码")
    @NotBlank(message = "注册密码不可为空")
    private String password;
}
