package com.zanxiang.sdk.service.Impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zanxiang.common.exception.ParamNullException;
import com.zanxiang.common.utils.StringUtils;
import com.zanxiang.common.utils.bean.BeanUtils;
import com.zanxiang.mybatis.entity.GameUser;
import com.zanxiang.mybatis.mapper.GameUserMapper;
import com.zanxiang.sdk.domain.params.GameUserUpdateParam;
import com.zanxiang.sdk.domain.params.UserData;
import com.zanxiang.sdk.service.GameUserService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.Objects;

/**
 * @author : xufeng
 * @time : 2022-07-06
 */
@Slf4j
@Service
public class GameUserImpl extends ServiceImpl<GameUserMapper, GameUser> implements GameUserService {

    @Override
    public Boolean updateGameUser(GameUserUpdateParam param, UserData userData) {
        if (StringUtils.isEmpty(param.getGameId())) {
            throw new ParamNullException("GameId");
        }
        Long gameId = Long.valueOf(param.getGameId());
        GameUser where = new GameUser();
        where.setUserId(userData.getUserId());
        where.setGameId(gameId);

        GameUser one = super.getOne(new LambdaQueryWrapper<GameUser>()
                .setEntity(where)
                .last("limit 1")
        );
        GameUser GameUserData = BeanUtils.copy(param, GameUser.class);
        GameUserData.setUserId(userData.getUserId());
        GameUserData.setGameId(gameId);
        if (Objects.isNull(one)) {
            //新增
            super.save(GameUserData);
        } else {
            //更新
            super.update(GameUserData, new UpdateWrapper<GameUser>().setEntity(where));
        }
        return true;
    }
}
