package com.zanxiang.sdk.service;

import com.zanxiang.common.domain.ResultVO;
import com.zanxiang.mybatis.entity.User;
import com.zanxiang.sdk.domain.dto.UserOauthDTO;
import com.zanxiang.sdk.domain.params.UserData;
import com.zanxiang.sdk.domain.params.UserOauthlUpdateParam;
import com.zanxiang.sdk.domain.vo.UserVO;

import java.util.Map;

/**
 * @author : lingfeng
 * @time : 2022-06-21
 * @description : 用户第三方授权信息
 */
public interface UserOauthService {

    /**
     * 根据openid查询用户授权信息
     *
     * @param openId : 用户第三方授权信息
     * @return : 返回用户授权信息
     */
    UserOauthDTO getUserOauthByOpenId(String openId);

    /**
     * 创建用户授权信息
     *
     * @param user : 用户信息
     * @param map  : 第三方用户信息
     * @return : 返回用户授权信息
     */
    UserOauthDTO createUserOauth(User user, Map<String, String> map);

    /**
     * 更新用户授权信息
     *
     * @param param
     * @param userData
     * @return
     */
    ResultVO<UserVO> updateUserOauth(UserOauthlUpdateParam param, UserData userData);
}
